## apex 1.4.15

=== Makefile ===
ARCH ?= arm

# Preserve environment for the cross-compiler
ENV_CROSS_COMPILE:=$(CROSS_COMPILE)

VERSION = 1
PATCHLEVEL = 4
SUBLEVEL = 15
EXTRAVERSION =
#NAME=Zonked Quokka

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's of
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call sparse as part of compilation of C files
# Use 'make C=1' to enable sparse checking

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntax'es are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assigment takes precedence over the KBUILD_OUTPUT environment variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
.PHONY: _all
_all:

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

.PHONY: $(MAKECMDGOALS)

$(filter-out _all,$(MAKECMDGOALS)) _all:
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT)		\
	KBUILD_SRC=$(CURDIR)	     KBUILD_VERBOSE=$(KBUILD_VERBOSE)	\
	KBUILD_CHECK=$(KBUILD_CHECK) KBUILD_EXTMOD="$(KBUILD_EXTMOD)"	\
	-f $(CURDIR)/Makefile $@

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
.PHONY: all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)

export srctree objtree VPATH TOPDIR

nullstring :=
space      := $(nullstring) # end of line

# Take the contents of any files called localversion* and the config
# variable CONFIG_LOCALVERSION and append them to KERNELRELEASE. Be
# careful not to include files twice if building in the source
# directory. LOCALVERSION from the command line override all of this

ifeq ($(objtree),$(srctree))
localversion-files := $(wildcard $(srctree)/localversion*)
else
localversion-files := $(wildcard $(objtree)/localversion* $(srctree)/localversion*)
endif

LOCALVERSION = $(subst $(space),, \
	       $(shell cat /dev/null $(localversion-files)) \
	       $(subst ",,$(CONFIG_LOCALVERSION)))

APEXRELEASE:=$(VERSION).$(PATCHLEVEL)
ifneq ($(SUBLEVEL),)
APEXRELEASE+=.$(SUBLEVEL)
endif
ifneq ($(EXTRAVERSION),)
APEXRELEASE+=$(EXTRAVERSION)
endif
ifneq ($(LOCALVERSION),)
APEXRELEASE+=$(LOCALVERSION)
endif
APEXRELEASE:=$(subst $(space),,$(APEXRELEASE))

# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile

ARCH		?= $(SUBARCH)

# elf: Removed in favor of the config file
#CROSS_COMPILE	?=

# Architecture as present in compile.h
UTS_MACHINE := $(ARCH)

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC	= gcc
HOSTCXX	= g++
HOSTCFLAGS	= -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
HOSTCXXFLAGS	= -O2

#	Decide whether to build built-in, modular, or both.
#	Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are uptodate before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN KBUILD_VERBOSE
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing wil be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's usefull
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE

######
# cc support functions to be used (only) in arch/$(ARCH)/Makefile
# See documentation in Documentation/kbuild/makefiles.txt

# cc-option
# Usage: cflags-y += $(call gcc-option, -march=winchip-c6, -march=i586)

cc-option = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
	     > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

# For backward compatibility
check_gcc = $(warning check_gcc is deprecated - use cc-option) \
	    $(call cc-option, $(1),$(2))

# cc-option-yn
# Usage: flag := $(call gcc-option-yn, -march=winchip-c6)
cc-option-yn = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
		> /dev/null 2>&1; then echo "y"; else echo "n"; fi;)

# cc-version
# Usage gcc-ver := $(call cc-version $(CC))
cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh \
	      $(if $(1), $(1), $(CC)))


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# For maximum performance (+ possibly random breakage, uncomment
# the following)

#MAKEFLAGS += -rR

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE_)as
LD		= $(CROSS_COMPILE_)ld
CC		= $(CROSS_COMPILE_)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE_)ar
NM		= $(CROSS_COMPILE_)nm
STRIP		= $(CROSS_COMPILE_)strip
OBJCOPY		= $(CROSS_COMPILE_)objcopy
OBJDUMP		= $(CROSS_COMPILE_)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= echo sparse
CHECKFLAGS     :=
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  = -r
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=

NOSTDINC_FLAGS  = -nostdinc -iwithprefix include

# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := -Iinclude \
		   $(if $(KBUILD_SRC),-Iinclude2 -I$(srctree)/include)

CPPFLAGS        := -D__KERNEL__ $(LINUXINCLUDE)

CFLAGS		:= -Wall -Wstrict-prototypes -Wno-trigraphs \
		   -fno-strict-aliasing -fno-common \
		   -fno-builtin-printf -g # -mthumb-interwork
AFLAGS		:= -D__ASSEMBLY__ # -mthumb-interwork

export	VERSION PATCHLEVEL SUBLEVEL EXTRAVERSION LOCALVERSION APEXRELEASE \
	ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE \
	HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE
export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# The temporary file to save gcc -MD generated dependencies must not
# contain a comma
comma := ,
depfile = $(subst $(comma),_,$(@D)/.$(@F).d)

=== arm-kernel-shim/Makefile ===
# Makefile

PACKAGE:=arm-kernel-shim
VERSION:=1.0

TOOLS:=/usr/arm-linux/gcc3/arm-linux-
CC=$(TOOLS)gcc
LD=$(TOOLS)ld
OBJCOPY=$(TOOLS)objcopy

CFLAGS:=-g -Os -nostartfiles -nostdlib
LDFLAGS:= -g -X -Map shim.map -Ttext 0

SRCS:= shim.lds main.c
OBJS:=$(SRCS:.c=.o)

$(PACKAGE).bin: $(PACKAGE)
	$(OBJCOPY) -O binary $< $@

$(PACKAGE): $(OBJS)
	$(LD) $(LDFLAGS) $(OBJS) -o $@

%.o: %.c
	$(CC) -c $(CFLAGS) $< -o $@


.PHONY: clean
clean:
	-rm *.o $(PACKAGE) $(PACKAGE).bin *~ *.map

.PHONY: package
package: $(PACKAGE)-$(VERSION).tar.gz

$(PACKAGE)-$(VERSION).tar.gz:
	[ ! -d $(PACKAGE)-$(VERSION) ] || rm -rf $(PACKAGE)-$(VERSION)
	svn export -q file:///svn/tools/trunk/$(PACKAGE) $(PACKAGE)-$(VERSION)
	tar zcvf $(PACKAGE)-$(VERSION).tar.gz $(PACKAGE)-$(VERSION)
	rm -rf $(PACKAGE)-$(VERSION)

=== usr/Makefile ===
# Makefile

CROSS_COMPILE ?= /usr/arm-linux/gcc3/arm-linux-
#CFLAGS ?= -I/a/trans/embedded/m3/tools-target/usr/include
#LDFLAGS ?= -L/a/trans/embedded/m3/tools-target/usr/lib

CFLAGS += -I../include

SRCS:=apex-env.cc mtdpartition.cc link.cc
OBJS:=$(SRCS:.cc=.o)

DEPS:=$(SRCS:%.cc=%.d)

CC=$(CROSS_COMPILE)g++
CXX=$(CROSS_COMPILE)g++
LD=$(CROSS_COMPILE)ld
STRIP=$(CROSS_COMPILE)strip

CFLAGS+= -Os -g -c
CFLAGS_LINK+= -g

TARGETS:=apex-env

.PHONY: all
all: $(TARGETS) groom

apex-env: $(OBJS)
	@echo linking $@
	@$(CC) $(CFLAGS_LINK) -o $@ $(OBJS) $(LIBRARIES) $($@_LIB)

%.o: %.cc
	@echo compile $<
	@$(CXX) $(CFLAGS) -o $@ $<

%.d: %.cc
	@set -e; rm -f $@; \
          $(CXX) -MM $(CFLAGS) $< > $@.$$$$; \
          sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
          rm -f $@.$$$$

.PHONY: clean
clean:
	-rm $(wildcard $(TARGETS) *.o *.d)

CRUFT:=$(wildcard  *.d.*)

.PHONY: groom
groom:
ifneq ($(CRUFT),)
	@rm $(CRUFT)
endif

-include $(DEPS)

=== scripts/lxdialog/Makefile ===
HOST_EXTRACFLAGS := -DLOCALE 
ifeq ($(shell uname),SunOS)
HOST_LOADLIBES   := -lcurses
else
HOST_LOADLIBES   := -lncurses
endif

ifeq (/usr/include/ncurses/ncurses.h, $(wildcard /usr/include/ncurses/ncurses.h))
        HOST_EXTRACFLAGS += -I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"
else
ifeq (/usr/include/ncurses/curses.h, $(wildcard /usr/include/ncurses/curses.h))
        HOST_EXTRACFLAGS += -I/usr/include/ncurses -DCURSES_LOC="<ncurses/curses.h>"
else
ifeq (/usr/include/ncurses.h, $(wildcard /usr/include/ncurses.h))
        HOST_EXTRACFLAGS += -DCURSES_LOC="<ncurses.h>"
else
	HOST_EXTRACFLAGS += -DCURSES_LOC="<curses.h>"
endif
endif
endif

hostprogs-y	:= lxdialog
always		:= ncurses $(hostprogs-y) lxdialog

lxdialog-objs := checklist.o menubox.o textbox.o yesno.o inputbox.o \
		 util.o lxdialog.o msgbox.o

.PHONY: $(obj)/ncurses
$(obj)/ncurses:
	@echo "main() {}" > lxtemp.c
	@if $(HOSTCC) lxtemp.c  $(HOST_LOADLIBES); then \
		rm -f lxtemp.c a.out; \
	else \
		rm -f lxtemp.c; \
		echo -e "\007" ;\
		echo ">> Unable to find the Ncurses libraries." ;\
		echo ">>" ;\
		echo ">> You must install ncurses-devel in order" ;\
		echo ">> to use 'make menuconfig'" ;\
		echo ;\
		exit 1 ;\
	fi

=== scripts/package/Makefile ===
# Makefile
#  for packaging

REPOS := "file:///svn/tools/trunk/apex"

PKGBASE := apex-$(APEXRELEASE)

.PHONY: tgz.pkg
tgz.pkg tgz:
ifneq "$(wildcard $(PKGBASE))" ""
	-rm -rf $(PKGBASE)
endif
	svn export -q $(REPOS) $(PKGBASE)
	find $(PKGBASE) -depth -type d -name '_intel' -exec rm -rf \{\} \;
	rm -rf $(PKGBASE)/include/splash
	tar zc\
	 --exclude='cc-png.h'\
	 --exclude='pcm*-*.h'\
	 --exclude='colorbars*.png'\
	 -f $(PKGBASE).tar.gz $(PKGBASE)
	@rm -rf $(PKGBASE)

help:
	@echo '  tgz             - Build a tar.gz file of the source'

=== src/arch-arm/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

LDFLAGS_apex := -p --no-undefined -X -g
OBJCOPYFLAGS := -O binary -R .note -R .comment -R .bss
GZFLAGS      := -9

# *** This lets the clean target work, but I'm not sure it's a good
# idea to include it.
-include .config
quote:="
# "
CONFIG_MACH:= $(subst $(quote),,$(CONFIG_MACH))

arch-$(CONFIG_CPU_ARMV4)   :=-D__ARM_ARCH__=4 -march=armv4t
arch-$(CONFIG_CPU_ARMV5)   :=-D__ARM_ARCH__=5 $(call cc-option,-march=armv5te,-march=armv4)

tune-$(CONFIG_CPU_ARM720T) :=-mtune=arm7tdmi
tune-$(CONFIG_CPU_ARM920T) :=-mtune=arm9tdmi
tune-$(CONFIG_CPU_ARM922T) :=-mtune=arm9tdmi
tune-$(CONFIG_CPU_ARM925T) :=-mtune=arm9tdmi
tune-$(CONFIG_CPU_ARM926T) :=-mtune=arm9tdmi
tune-$(CONFIG_CPU_XSCALE)  :=$(call cc-option,-mtune=xscale,-mtune=strongarm110) -Wa,-mcpu=xscale

CFLAGS+= $(arch-y) $(tune-y) -Wall

ifneq ($(CONFIG_THUMB),)
CFLAGS+= -mthumb-interwork
AFLAGS+= -mthumb-interwork
endif

init-y += src/arch-arm/entry/
core-y += src/mach-$(CONFIG_MACH)/
core-y += src/drivers/ src/net/ src/arch-arm/linux/
core-$(CONFIG_DRIVERS_LH) +=  src/drivers-lh/
libs-y += src/arch-arm/lib/

-include src/mach-$(CONFIG_MACH)/Makefile.libs

rom := src/arch-arm/rom

apex.bin apex.bin_swap apex.elf apex.srec :\
		 include/config.h apex
	$(Q)$(MAKE) $(build)=$(rom) $(rom)/$@

=== src/drivers-lh/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004,2005 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

obj-$(CONFIG_DRIVER_LH_ADC)	+= adc.o
obj-$(CONFIG_DRIVER_LH_MMC)	+= drv-mmc.o
obj-$(CONFIG_DRIVER_LH_CLCDC)	+= drv-clcdc.o
obj-$(CONFIG_DRIVER_LH_I2C)	+= drv-i2c.o

=== src/lib/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

lib-y := vsprintf.o ctype.o
lib-y += strlen.o strnlen.o strchr.o strlcpy.o strcat.o strcpy.o
lib-y += strcmp.o strnicmp.o strcspn.o
lib-y += memcmp.o memset.o
lib-$(CONFIG_SMALL) += memcpy.o memmove.o
lib-y += crc32.o xmodem.o
lib-y += spinner.o
lib-$(CONFIG_ENV) += env.o
lib-y += dump.o
lib-y += zlib.o zlib-heap.o
#lib-y += png.o
lib-y += pngr.o
lib-y += sort.o
lib-$(CONFIG_ALIASES) += alias.o
lib-y += lookup.o
lib-y += memtest.o

ifneq ($(CONFIG_THUMB),)
CFLAGS_vsprintf.o	+= -mthumb
CFLAGS_ctype.o		+= -mthumb
#CFLAGS_xmodem.o		+= -mthumb -mcaller-super-interworking
CFLAGS_strlen.o		+= -mthumb
CFLAGS_strnlen.o	+= -mthumb
CFLAGS_strrchr.o	+= -mthumb
CFLAGS_strlcpy.o	+= -mthumb
CFLAGS_strnicmp.o	+= -mthumb
CFLAGS_strcpy.o		+= -mthumb
CFLAGS_memcmp.o		+= -mthumb
CFLAGS_memset.o		+= -mthumb
CFLAGS_memcpy.o		+= -mthumb
CFLAGS_memmove.o	+= -mthumb
CFLAGS_png.o		+= -mthumb
endif

#lib-y += div64.o
#lib-y += udiv.o
#CFLAGS_vsprintf.o += -mthumb
#CFLAGS_crc32.o = -mthumb -mthumb-interwork

=== src/mach-ixp42x/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

# npe-interface is in a world of it's own.  It has to build with
#   headers from the Intel Access Library which are incompatible with
#   header in the project.  So, it is isolated from the loader and
#   wrapper calls are defined to allow the header domain of the this
#   one source file to be separate from the header domain of the rest
#   of the application.

CFLAGS_npe-interface.o\
  += -I-\
     -Isrc/mach-ixp42x/_intel/ixp400_xscale_sw/src/include \
     -Isrc/mach-ixp42x/_intel/ixp_osal/include\
     -Isrc/mach-ixp42x/_intel/ixp_osal/os/linux/include/core\
     -Isrc/mach-ixp42x/_intel/ixp_osal/os/linux/include/modules/bufferMgt\
     -Isrc/mach-ixp42x/_intel/ixp_osal/os/linux/include/platforms/ixp400\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/modules/ioMem\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/modules/bufferMgt\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/platforms/ixp400\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/platforms/ixp400/bufferMgt\
     -Isrc/mach-ixp42x/_intel/linux/include\
     -Isrc/mach-ixp42x/_intel/linux/include/linux\
     -Isrc/mach-ixp42x/_intel/linux/include/asm/arch\
     -Isrc/mach-ixp42x/_intel/ixp400_xscale_sw/npeLib

obj-y := serial.o env.o cpuinfo.o
obj-y += initialize.o timer.o pci.o

obj-x$(CONFIG_MACH_NSLU2)$(CONFIG_SPINNER) += spinner-nslu2.o
obj-x$(CONFIG_MACH_NSLU2)$(CONFIG_VARIATIONS) += variation-nslu2.o
obj-$(CONFIG_INTERRUPTS)	+= exception_vectors.o

obj-$(CONFIG_NPE)		+= npe.o npe-interface.o

obj-$(CONFIG_DRIVER_IXP4XX_NPE_ETH) += drv-npe.o

obj-y				+= cmd-reset.o

obj-y += $(obj-xyy)

libs-$(CONFIG_NPE) += _intel/lib/libnpeDl.a
newlibs += $(obj)/_intel/lib/libnpeDl.a

#libs-$(CONFIG_NPE) := _intel/

=== src/mach-lh7952x/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

obj-y := serial.o env.o cpuinfo.o

obj-$(CONFIG_MACH_LNODE80)      += init-lnode80.o timer-lh79520.o
obj-$(CONFIG_MACH_LPD79520)     += init-lpd79520.o timer-lh79520.o

obj-$(CONFIG_MACH_LPD79524)     += init-lpd79524.o timer-lh79524.o
obj-$(CONFIG_MACH_KEV79524)     += init-kev79524.o timer-lh79524.o
obj-$(CONFIG_MACH_LPD79525)     += init-lpd79524.o timer-lh79524.o
obj-$(CONFIG_MACH_KEV79525)     += init-kev79524.o timer-lh79524.o

obj-x$(CONFIG_INTERRUPTS)$(CONFIG_ARCH_LH79524)	+= exception_vectors.o
obj-$(CONFIG_DRIVER_NAND)	+= drv-nand.o
obj-$(CONFIG_DRIVER_CPLD_SPI)	+= drv-cpld-spi.o
obj-$(CONFIG_DRIVER_EMAC_LH79524) += drv-emac.o
obj-$(CONFIG_RELOCATE_NAND)	+= relocate-nand.o
obj-$(CONFIG_CLCDC)		+= clcdc.o
obj-$(CONFIG_CODEC)		+= codec.o
obj-$(CONFIG_CODEC_LH79520)	+= codec-lh79520.o
obj-$(CONFIG_ADS7843)		+= ads7843.o
obj-y				+= cmd-reset.o

obj-y += $(obj-xyy)

=== src/mach-lh7a40x/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

obj-y := arch.o initialize.o serial.o timer.o env.o cpuinfo.o
obj-$(CONFIG_CLCDC)		+= clcdc.o
obj-$(CONFIG_CODEC)		+= codec.o
obj-$(CONFIG_ADC)		+= adc.o
obj-y				+= cmd-reset.o
obj-y				+= cmd-standby.o
obj-$(CONFIG_CMD_ARM920_TEST)	+= cmd-cp15test.o
obj-$(CONFIG_RELOCATE_COMPANION_EVT1) += relocate-companion.o
obj-$(CONFIG_MACH_COMPANION)    += clcdc-companion.o
obj-$(CONFIG_RELOCATE_COMPANION_EVT2) += preinitialization-companion.o

obj-$(CONFIG_MACH_COMPANION)	+= test-companion.o
obj-x$(CONFIG_MACH_COMPANION)$(CONFIG_VARIATIONS) += variation-companion.o

obj-y += $(obj-xyy)

=== src/mach-mx3/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2006 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA.
#

obj-y := initialize.o serial.o timer.o env.o cpuinfo.o
obj-y				+= cmd-reset.o
#obj-y				+= cmd-standby.o

=== debian/changelog ===
apex (1.4.15) unstable; urgency=low

  * Modified the rules file to support cross-building.
  * Closes bug#409189
  * Fixed the output file name.  It was inadvertently changed to /boot/apex.bin
    from /boot/apex.flash.
  * Closes bug#409747
 -- Marc Singer <elf@buici.com>  Mon,  5 Feb 2007 18:35:11 -0800

apex (1.4.14) unstable; urgency=low

  * Revised the libfuncs1.S file for arm so that armel can build.
  * Closes bug#408443
  * Changed the rules file to drop the executble bit on the apex.flash
    file written to /boot.
  * Closes bug#396447

 -- Marc Singer <elf@buici.com>  Tue, 30 Jan 2007 19:19:55 -0800

apex (1.4.13) unstable; urgency=low

  * Fixed ext2 driver caching s.t. multiple partitions work correctly.
  * New user-mode application for modifying the APEX environment.
  * Revisions to Companion setup.
  * Revision to the memory test based on advice about what is useful and
    what is not.
  * Fixes to the FIS driver for swapped-ness and end-of-table detection.
  * Applied rwhitby's patches for a couple of ixp4xx devices as well as
    some other minor patches.
  * Added variation support for alternative boot modes.
  * Enhanced NAND support and made it more generic.

 -- Marc Singer <elf@cerise.buici.com>  Sat, 27 Jan 2007 17:38:49 -0800

=== debian/control ===
Source: apex
Section: admin
Priority: optional
Maintainer: Marc Singer <elf@debian.org>
Standards-Version: 3.7.2
Build-Depends: perl, debhelper (>= 5)

Package: apex-nslu2
Architecture: arm armeb armel
Depends:
Description: APEX Boot Loader for Linksys NSLU2 
 The APEX Boot Loader is a modular and retargetable firmware loader
 suitable for embedded systems.  
 .
 This package is a version of APEX configured for the Linksys NSLU2
 network appliance.  In this case, APEX is used as a second stage
 loader so that Redboot, as installed by the manufacturer, may remain.
 . 
 The APEX command line offers a comfortable (e.g. command line editing
 and history) and extensible platform for development and production
 uses.
 .
 <http://wiki.buici.com/wiki/Apex_Bootloader>

=== debian/rules ===
#!/usr/bin/make -f

package = apex-nslu2
docdir = debian/tmp/usr/share/doc/$(package)

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
CONFIG	      := debian-nslu2-$(DEB_HOST_ARCH)_config

CC = gcc
CFLAGS = -g -Wall
INSTALL_PROGRAM = install


ifeq (arm,$(DEB_HOST_ARCH))
 ENDIAN:=l
endif
ifeq (armel,$(DEB_HOST_ARCH))
 ENDIAN:=l
endif
ifeq (armeb,$(DEB_HOST_ARCH))
 ENDIAN:=b
endif

# We must not change the build options.
#ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
#  CFLAGS += -O2
#endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  INSTALL_PROGRAM += -s
endif

build:
	$(checkdir)
	$(MAKE) $(CONFIG)
	$(MAKE)
	$(MAKE) -C usr CROSS_COMPILE=
	touch build

clean:
	$(checkdir)
	rm -f build
	-$(MAKE) -i distclean
	rm -rf *~ debian/tmp debian/*~ debian/files* debian/substvars

binary-indep:	checkroot build
	$(checkdir)
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.

binary-arch:	checkroot build
	$(checkdir)
	rm -rf debian/$(package)
	dh_testroot -a
	dh_installdirs
	install -d debian/$(package)/boot
	install -d debian/$(package)/usr/sbin
	install -m 0644 src/arch-arm/rom/apex.bin\
                  debian/$(package)/boot/apex.flash
	install -m 0755 usr/apex-env debian/$(package)/usr/sbin
	dh_strip
	dh_installchangelogs ChangeLog
	dh_installdocs -a
	dh_installman usr/apex-env.8
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

define checkdir
	test -f src/apex/init.c -a -f debian/rules
endef

binary: binary-indep binary-arch

checkroot:
	$(checkdir)
	test $$(id -u) = 0

.PHONY: binary binary-arch binary-indep clean checkroot

## apex 1.4.15.2

=== debian/changelog ===
apex (1.4.15.2) unstable; urgency=low

  * debian/postinst: Fixed the postinst script to only run on the NSLU2.
    (closes: #482000)
  * Makefile: Fixed the construction of the version when there is an
    EXTRAVERSION.

 -- Marc Singer <elf@buici.com>  Tue, 20 May 2008 20:34:48 -0700

apex (1.4.15.1) unstable; urgency=low

  * Release of old APEX version during Debian freeze.
  * Adding flash-apex so that apex is written to flash on install of the
    package (closes: #421359).
  * Expanding CONFIG_RAMDISK_SIZE (closes: #451882).
  
 -- Marc Singer <elf@buici.com>  Sun, 18 May 2008 14:37:51 -0700

=== debian/rules ===
--- 
+++ 
@@ -58,13 +58,16 @@
 	install -m 0644 src/arch-arm/rom/apex.bin\
                   debian/$(package)/boot/apex.flash
 	install -m 0755 usr/apex-env debian/$(package)/usr/sbin
+	install -m 0755 usr/flash-apex debian/$(package)/usr/sbin
 	dh_strip
 	dh_installchangelogs ChangeLog
 	dh_installdocs -a
 	dh_installman usr/apex-env.8
+	dh_installman usr/flash-apex.8
 	dh_compress -a
 	dh_fixperms -a
 	dh_installdeb -a
+	dh_shlibdeps
 	dh_gencontrol -a
 	dh_md5sums -a
 	dh_builddeb -a

## apex 1.4.15.2ubuntu3

=== debian/changelog ===
apex (1.4.15.2ubuntu3) jaunty; urgency=low

  * moving apex to 3MiB apparently was not enough, it seems to corrupt the
    kernel (ours is biger than debians) during copying into ram by overwriting
    pieces of the kernel with apex, moving to 4MiB fixes that issue properly now.

 -- Oliver Grawert <ogra@ubuntu.com>  Mon, 16 Feb 2009 14:16:20 +0100

apex (1.4.15.2ubuntu2) jaunty; urgency=low

  * set VMA address for apex to 3MiB so a kernel bigger than 2M doesnt
    overwrite apex when being loaded
  * set CONFIG_RAMDISK_SIZE=0x0055FFF0 instead of 0x005FFFF0 to avoid a kernel
    panic when loading the initramfs (needs more research, can probably be
    changed later again)

 -- Oliver Grawert <ogra@ubuntu.com>  Thu, 12 Feb 2009 12:32:06 +0100

apex (1.4.15.2ubuntu1) jaunty; urgency=low

  * Unexport LDFLAGS to avoid confusing the kernel with dpkg-buildpackage's
    default options.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 17 Dec 2008 17:33:20 +0000
